# FAQ
## 交叉编译器下载及部署
目前交叉编译器安装包单独提供，需要找kylinTeam获取下载方式。目前只提供三种架构的交叉编译器：x86_64、arm64、loongarch64。每种架构提供两种另外两种架构的交叉编译器，一共6种。例如arm64则有两种交叉编译器：x64-cross-compile-tools-on-aarch64.tar.gz和loongarch64-cross-compile-tools-on-arm64.tar.gz。  
获取的交叉编译器压缩解压之后目录结构类似：
![图1](./resources/tree.png)
### 配置
有些架构需要运行交叉编译工具目录里面的`config_compiler.sh`, 配置交叉编译工具。
## 编译大型项目时依赖库找不到
可以通过两种方式解决
 - 从交叉编译目标环境(或者说是生产运行环境)复制对应版本的头文件和库文件到sysroot目录
 - 先交叉编译缺少的对应版本依赖库，编译完成之后，在安装进sysroot目录
### 例子
由于sysroot中只有目标架构的基础包，当编译一个依赖较多的复杂软件时，提供的sysroot中可能不包含某个依赖包，这时需要用户自己先交叉编译依赖包，并安装到sysroot中。例如在编译FFmpeg时缺少x264解码器时，对x264源码包的编译安装：
``` shell
tar xvf x264-20230215.tar.xz 
cd x264-20230215
./configure --prefix=/usr --libdir=/usr/lib64 \
         --cross-prefix=${CROSS_TARGET}-  --sysroot=${SYSROOT} \
         --host=${CROSS_TARGET} --enable-shared --disable-cli \
         --enable-pic --enable-lto
make ${JOBS}
make DESTDIR=${SYSROOT} install
```
DESTDIR=${SYSROOT} 指定安装到sysroot路径下。sysroot中就安装了x264，FFmpeg就可以支持x264解码器。


## 链接时找不到std相关函数的符号
查看编译命令，检查编译器是否正确，例如使用系统默认编译器、使用gcc编译cpp文件、使用g++编译c文件。更或者sysroot没有配置。

## configure项目生成Makefile时出现test失败
某些configure项目生成Makefile过程中会编译生成一个临时的conftest可执行文件，并尝试运行测试。但是在宿主机上无法运行交叉编译目标架构程序，
所以需要修改configure文件，把运行测试的代码删除。
