[中文](#交叉编译插件)|[English](#cross-compile)
# 交叉编译插件
## 1. 概述
- 在Kylin-IDE中使用交叉编译工具构建新的项目
- 由于现有项目复杂多变，无法修改编译构建脚本来实现交叉编译功能，所有对现有的项目进行交叉编译只进行使用说明

主要功能

- 创建新的项目
- 现有的项目如今进行交叉编译进行说明

## 2. 使用
- 启动集成开发环境
- 点击点击左侧活动栏图标“交叉编译”
- 点击`创建新的项目`按钮，可以配置新的交叉编译项目
- 点击`现有工程使用说明`按钮，可以选择对现有的项目如今进行交叉编译进行说明
### 2.1. 创建新的项目
点击`创建新的项目`按钮，打开一个新的页面，可以配置新的交叉编译项目。可以设置项目名称、路径、程序语言、编译目标名称、
选择合适的编译器、自定义编译参数。
#### 2.1.1. 编译器类型配置
默认的编译器是系统的gcc/g++。

#### 2.1.2. 添加交叉编译器
点击“+”添加新的编译器,填写适当的内容；
- “CC”为编译C语言源文件的编译器；
- “CXX”为编译CPP语言源文件的编译器；
- “sysroot”为编译器依赖库的基础软件包路径，默认的gcc/g++编译器可以为空；如果是自行下载的交叉编译器必须指定sysroot目录。  

最后点击“应用”。

**交叉编译器需要找KylinTEAM提供**

### 2.2. 现有项目交叉编译说明
点击`现有工程使用说明`按钮  
**提供三种构建脚本的修改，来使用交叉编译功能，包括configure、Makefile、cmake。FAQ为常见问题说明**

## 3. 插件源码构建
### 3.1. 插件构建
``` shell
    npm i 
    npm run build
    vsce package
```
### 3.2. 测试前端
目前有两个页面，根据需要显示其中一个页面；在`webpack.config.ts`中配置`export default`的webpack选项
``` shell
    npm
    npm run serve
```
浏览器打开 [http://localhost:8080/](http://localhost:8080/)。

---
# Cross compile
## 1. Overview
- Building a new project in Kylin-IDE using cross-compilation tools
- Due to the complexity and variability of existing projects, it is not possible to modify the compilation build script to achieve the cross-compile function, all the cross-compilation of existing projects only to use the instructions.

Functions

- Create a new project
- Existing projects are now cross-compiled for illustration.

## 2. Use
- Starting the IDE
- Click on the icon "Cross-compile" in the left hand activity bar.
- Click on the `Create new project` button to configure a new cross-compile project.
- Click on the `Existing project description` button to choose to describe the cross-compilation of an existing project.

### 2.1. Creating a new project
Clicking on the `Create new project` button opens a new page where you can configure a new cross-compilation project. You can set the project name, path, programming language, and compilation target name,
Select the appropriate compiler, and customise the compilation parameters.

#### 2.1.1. Compiler Type Configuration
The default compiler is gcc/g++.

#### 2.1.2. Adding Cross-compiler
Click "+" to add a new compiler, fill in the appropriate fields;
- "CC" is the compiler for compiling C source files;
- "CXX" is the compiler for compiling CPP language source files;
- "sysroot" is the path to the base package of the compiler's dependency libraries, the default gcc/g++ compiler can be empty; if you download the cross-compiler yourself, you must specify the sysroot directory.  

Finally click "Apply".

**Cross-compiler needs to be provided by KylinTEAM**.

### 2.2. Instructions for cross-compiling an existing project
Click on the `Instructions for Existing Projects` button  
**Provide three build script modifications to use the cross-compile feature, including configure, makefile, cmake and FAQ.**

## 3. Extension Source Build
### 3.1. Extension builds
``` shell
    npm i 
    npm run build
    vsce package
```
### 3.2. Testing the front-end
There are currently two pages, display one of them as needed; configure the webpack option `export default` in webpack.config.ts
``` shell
    npm
    npm run serve
```
Open [http://localhost:8080/](http://localhost:8080/) in your browser.