# 使用configure构建工具的源码包进行交叉编译
## 定义环境变量
首先先确定一些概念
- `CROSS_HOST`：**主系统**所使用的架构系统描述词，比如x86_64-linux-gnu
- `CROSS_TARGET`：**目标系统**所使用的架构系统描述词，比如aarch64-unknown-linux-gnu、loongarch64-unknown-linux-gnu
- `sysroot`:因为在编译gcc时指定了--with-sysroot参数，所以gcc在编译其他文件时默认会去使用这个sysroot路径，如果这个sysroot路径不存在，用户就需要使用--sysroot参数指定sysroot的存放路径  

可在环境变量中预先设置一些常用的变量
``` shell
export SYSROOT=/path/sysroot
export PATH=$PATH:/path/cross-tools/bin
export LDFLAGS="-Wl,-rpath-link=${SYSROOT}/usr/lib64"
export PKG_CONFIG_SYSROOT_DIR=${SYSROOT}
export PKG_CONFIG_PATH="${SYSROOT}/usr/lib64/pkgconfig:${SYSDIR}/sysroot/usr/share/pkgconfig"
export CROSS_HOST=x86_64-linux-gnu
export CROSS_TARGET=aarch64-unknown-linux-gnu
```
Host作为当前编译环境代称，target作为目标系统代称
## 查看configure配置帮助
命令`configure --help`可以查看项目支持的编译配置参数。
## 配置交叉编译
先确保交叉编译器在系统bin目录下或者在PATH环境变量中。  
使用configure构建的源码包，一般情况下，configure脚本支持“--build=”“--host=”参数，在执行configure命令时加上参数`--build=${CROSS_HOST}`、 `--host=${CROSS_TARGET}` 就表明了是交叉编译。  
如果sysroot的存放路径不是编译器默认的路径，只指定“--build=”“--host=”参数是不行的，还需要指定sysroot的路径`--sysroot=/path/sysroot/`来指定。
## 例子
例如对make源码的交叉编译：
``` shell
tar xvf make-4.4.1.tar.gz
cd make-4.4.1
./configure --prefix=/usr --libdir=/usr/lib64 --build=${CROSS_HOST} --host=${CROSS_TARGET}
make 
```