# 使用Makefile的源码包进行交叉编译
## makefile编译配置一般在环境变量中或者makefile文件中
## 有些Makefile里面使用了类似CC、CXX环境变量
可以通过指定环境变量CC、CXX来指定交叉编译器
``` shell
export SYSROOT=/path/sysroot
export PATH=$PATH:/path/cross-tools/bin
export CC=aarch64-linux-gnu-gcc
export CXX=/cross-compile/bin/aarch64-linux-gnu-g++
```
## 例子
例如对lua源码的交叉编译：  
解压源文件
``` shell
tar xvf lua-5.4.0.tar.gz
cd lua-5.4.0
```
修改makefile文件
```diff
diff --git a/C/src/Makefile b/C/src/Makefile
index 1907381..85b176b 100644
--- a/C/src/Makefile
+++ b/C/src/Makefile
@@ -6,9 +6,9 @@
 # Your platform. See PLATS for possible values.
 PLAT= guess
 
-CC= gcc -std=gnu99
-CFLAGS= -O2 -Wall -Wextra -DLUA_COMPAT_5_3 $(SYSCFLAGS) $(MYCFLAGS)
-LDFLAGS= $(SYSLDFLAGS) $(MYLDFLAGS)
+CC?= gcc -std=gnu99
+CFLAGS= -O2 -Wall -Wextra -DLUA_COMPAT_5_3 $(SYSCFLAGS) $(MYCFLAGS) --sysroot=${SYSROOT}
+LDFLAGS= $(SYSLDFLAGS) $(MYLDFLAGS) --sysroot=${SYSROOT}
 LIBS= -lm $(SYSLIBS) $(MYLIBS)
 
 AR= ar rcu

```
编译
```
make -j4
```